function RequireFiles()
require 'variables'
require 'terrainGenerate'
require 'mobs'
require 'weapons'
require 'Inventory'
require 'drawWorld'
require 'furnace'
require 'runicAltar'
require 'breakAndPlaceBlocks'
require 'player'
require 'generator'
require 'machineInventories'
require 'wire'
end 

function BlockImages()


dirt = love.graphics.newImage("textures/dirt.png")
leaf = love.graphics.newImage("textures/leaf.png")
stone = love.graphics.newImage("textures/stone.png")
wood = love.graphics.newImage("textures/log.png")
grass = love.graphics.newImage("textures/grass.png")
grid = love.graphics.newImage("textures/InventoryGrid.png")
GoldOre = love.graphics.newImage("textures/GoldOre.png")
DiamondOre = love.graphics.newImage("textures/DiamondOre.png")
IronOre	= love.graphics.newImage("textures/IronOre.png")
Character = love.graphics.newImage("textures/Character.png")
Pickaxe = love.graphics.newImage("textures/Pickaxe.png")
PhysicsWood = love.graphics.newImage("textures/PhysicsLog.png")
CraftingTable = love.graphics.newImage("textures/CraftingTable.png")
stick = love.graphics.newImage("textures/Stick.png")
woodPlank = love.graphics.newImage("textures/woodPlank.png")
SmoothStone = love.graphics.newImage("textures/SmoothStone.png")
Sand = love.graphics.newImage("textures/Sand.png")
Glass = love.graphics.newImage("textures/Glass.png")


StonePickaxeHead = love.graphics.newImage("textures/StonePickaxeHead.png")
WoodPickaxeHead = love.graphics.newImage("textures/WoodPickaxeHead.png")
WoodPickaxe = love.graphics.newImage("textures/WoodPickaxe.png")
StonePickaxe = love.graphics.newImage("textures/StonePickaxe.png")
furnace = love.graphics.newImage("textures/Furnace.png")
IronIngot = love.graphics.newImage("textures/IronIngot.png")
IronPickaxeHead = love.graphics.newImage("textures/IronPickaxeHead.png")
IronPickaxe = love.graphics.newImage("textures/IronPickaxe.png")

WoodAxeHead = love.graphics.newImage("textures/WoodAxeHead.png")
StoneAxeHead = love.graphics.newImage("textures/StoneAxeHead.png")
IronAxeHead = love.graphics.newImage("textures/IronAxeHead.png")
GoldAxeHead = love.graphics.newImage("textures/GoldAxeHead.png")
DiamondAxeHead = love.graphics.newImage("textures/DiamondAxeHead.png")

WoodAxe = love.graphics.newImage("textures/WoodAxe.png")
StoneAxe = love.graphics.newImage("textures/StoneAxe.png")
IronAxe = love.graphics.newImage("textures/IronAxe.png")
GoldAxe = love.graphics.newImage("textures/GoldAxe.png")
DiamondAxe = love.graphics.newImage("textures/DiamondAxe.png")

WoodShovelHead = love.graphics.newImage("textures/WoodShovelHead.png")
StoneShovelHead = love.graphics.newImage("textures/StoneShovelHead.png")
IronShovelHead = love.graphics.newImage("textures/IronShovelHead.png")
GoldShovelHead = love.graphics.newImage("textures/GoldShovelHead.png")
DiamondShovelHead = love.graphics.newImage("textures/DiamondShovelHead.png")

WoodShovel = love.graphics.newImage("textures/WoodShovel.png")
StoneShovel = love.graphics.newImage("textures/StoneShovel.png")
IronShovel = love.graphics.newImage("textures/IronShovel.png")
GoldShovel = love.graphics.newImage("textures/GoldShovel.png")
DiamondShovel = love.graphics.newImage("textures/DiamondShovel.png")

GoldIngot = love.graphics.newImage("textures/GoldIngot.png")
Diamond = love.graphics.newImage("textures/Diamond.png")

GoldPickaxeHead = love.graphics.newImage("textures/GoldPickaxeHead.png")
DiamondPickaxeHead = love.graphics.newImage("textures/DiamondPickaxeHead.png")

GoldPickaxe = love.graphics.newImage("textures/GoldPickaxe.png")
DiamondPickaxe = love.graphics.newImage("textures/DiamondPickaxe.png")

MachineBlock = love.graphics.newImage("textures/MachineBlock.png")
ElectronicCircut = love.graphics.newImage("textures/ElectronicCircut.png")
Generator = love.graphics.newImage("textures/Generator.png")
ElectricFurnace = love.graphics.newImage("textures/ElectricFurnace.png")

CoalOre = love.graphics.newImage("textures/CoalOre.png")
Coal = love.graphics.newImage("textures/Coal.png")

ElectrumOre = love.graphics.newImage("textures/ElectrumOre.png")
ElectrumIngot = love.graphics.newImage("textures/ElectrumIngot.png")

CopperOre = love.graphics.newImage("textures/CopperOre.png")
CopperIngot = love.graphics.newImage("textures/CopperIngot.png")

ElectrumWire = love.graphics.newImage("textures/ElectrumWire.png")
CopperWire = love.graphics.newImage("textures/CopperWire.png")

IronPlate = love.graphics.newImage("textures/IronPlate.png")

Grinder = love.graphics.newImage("textures/Grinder.png")
Compressor = love.graphics.newImage("textures/Compressor.png")
BlastFurnace = love.graphics.newImage("textures/BlastFurnace.png")

Coil = love.graphics.newImage("textures/Coil.png")

IronDust = love.graphics.newImage("textures/IronDust.png")
GoldDust = love.graphics.newImage("textures/GoldDust.png")
CopperDust = love.graphics.newImage("textures/CopperDust.png")
ElectrumDust = love.graphics.newImage("textures/ElectrumDust.png")

SolarPanel = love.graphics.newImage("textures/SolarPanel.png")

Seeds = love.graphics.newImage("textures/Seeds.png")
Wheat = love.graphics.newImage("textures/Wheat.png")
Flour = love.graphics.newImage("textures/Flour.png")
Bread = love.graphics.newImage("textures/Bread.png")

DoubleJumpPendant = love.graphics.newImage("textures/DoubleJumpPendant.png")
HighJumpPendant = love.graphics.newImage("textures/HighJumpPendant.png")
InvisibiltyPendant = love.graphics.newImage("textures/InvisibilityPendant.png")

BatteryBank = love.graphics.newImage("textures/BatteryBank.png")

BackGroundIsland1 = love.graphics.newImage("textures/BackGroundIsland1.png")
BackGroundIsland2 = love.graphics.newImage("textures/BackGroundIsland2.png")

Cloud1 = love.graphics.newImage("textures/Cloud1.png")
Cloud2 = love.graphics.newImage("textures/Cloud2.png")

Background = love.graphics.newImage("textures/Background.png")



door = love.graphics.newImage("textures/door.png")

MagicPickaxe = love.graphics.newImage("textures/MagicPickaxe.png")
MagicParticle = love.graphics.newImage("textures/MagicParticle.png")
JumpParticle = love.graphics.newImage("textures/JumpParticle.png")
SwordParticle = love.graphics.newImage("textures/SwordParticle.png")

Rune = love.graphics.newImage("textures/Rune.png")

BlueFlower = love.graphics.newImage("textures/BlueFlower.png")
RedFlower = love.graphics.newImage("textures/RedFlower.png")
YellowFlower = love.graphics.newImage("textures/YellowFlower.png")

WaterRune = love.graphics.newImage("textures/WaterRune.png")
FireRune = love.graphics.newImage("textures/FireRune.png")
AirRune = love.graphics.newImage("textures/AirRune.png")
EarthRune = love.graphics.newImage("textures/EarthRune.png")

RunicAltar = love.graphics.newImage("textures/RunicAltar.png")
MiningStaff = love.graphics.newImage("textures/MiningStaff.png")

MagicDiamond = love.graphics.newImage("textures/MagicDiamond.png")
MagicParticle = love.graphics.newImage("textures/MagicParticle.png")

Arrow = love.graphics.newImage("textures/Arrow.png")
BackArrow = love.graphics.newImage("textures/BackArrow.png")
UpArrow = love.graphics.newImage("textures/UpArrow.png")
DownArrow = love.graphics.newImage("textures/DownArrow.png")

Wrench = love.graphics.newImage("textures/Wrench.png")

SteelIngot = love.graphics.newImage("textures/SteelIngot.png")

DiamondSword = love.graphics.newImage("textures/DiamondSword.png")
DiamondSwordBlade = love.graphics.newImage("textures/DiamondSwordBlade.png")

DiamondBattleAxe = love.graphics.newImage("textures/DiamondBattleAxe.png")

end

function love.load()
RequireFiles()


parameters()
BlockImages()



for i = 1, love.math.random(2,6) do 
local randNumber = love.math.random(1,4)
BackgroundIslandPos.x[i] = love.math.random(0,2000)
BackgroundIslandPos.y[i] = love.math.random(0,600)
BackgroundIslandPos.size[i] = love.math.random(1,1)
if randNumber == 1 then 
BackgroundIslandPos.image[i] = BackGroundIsland1 
elseif randNumber == 2 then 
BackgroundIslandPos.image[i] = BackGroundIsland2
elseif randNumber == 3 then 
BackgroundIslandPos.image[i] = Cloud1 
elseif randNumber == 4 then 
BackgroundIslandPos.image[i] = Cloud2
end 
end 

jumpParticles = love.graphics.newParticleSystem(JumpParticle,16 )
jumpParticles:setParticleLifetime(0.5,1); -- Particles live at least 2s and at most 5s.
jumpParticles:setLinearAcceleration(40, -10,75,300); -- Randomized movement towards the bottom of the screen.
jumpParticles:setColors(255, 255, 255, 255, 255, 255, 255, 0); -- Fade to black.

breakParticles = love.graphics.newParticleSystem(JumpParticle,8)
breakParticles:setParticleLifetime(1,3)
breakParticles:setLinearAcceleration(-1,-5,25,100)
breakParticles:setColors(255,255,255,255,255,255,255,0)
breakParticlesX = 0 
breakParticlesY = 0 

MagicParticles = love.graphics.newParticleSystem(MagicParticle,32)
MagicParticles:setParticleLifetime(2,5)
MagicParticles:setLinearAcceleration(-1,-2,25,100)
MagicParticles:setColors(255,255,255,255,255,255,255,0)
magicParticleX = 0 
magicParticleY = 0 

magicToolParticles = love.graphics.newParticleSystem(MagicParticle,5)
magicToolParticles:setParticleLifetime(1,4)
magicToolParticles:setLinearAcceleration(100,-5,25,100)
magicToolParticles:setColors(255,255,255,255,255,255,255,0)
--love.window.setFullscreen("true",normal)

SwordParticles = love.graphics.newParticleSystem(SwordParticle,128)
SwordParticles:setParticleLifetime(1,2)
SwordParticles:setLinearAcceleration(100,-5,25,100)
SwordParticles:setColors(255,255,255,255,255,0,0,0)

love.window.setMode(1900,1000,{resizable=true})


for i = 1,45000 do
--Blocks[i] = 0
BlockImage[i] = 0
BlockImage.blackened[i] = true 
end

IslandOffset = 0
GenerateTerrain()
IslandOffset = 135+WidthOfWorld*10
GenerateTerrain()
IslandOffset = 350 
GenerateTerrain()


Slot1[1] = Pickaxe
Slot2[1] = CraftingTable


local lengthCounter = 0 

for i = 1,20 do 
lengthCounter = lengthCounter+1
Inventory.length[lengthCounter] = 0
end 



for i = 1,#BlockImage+WidthOfWorld do
PosCounter = PosCounter+1
if PosCounter == 500 then
RowCounter = RowCounter+1
PosCounter = 0
end

BlocksX[i] = PosCounter
BlocksY[i] = RowCounter

end 


Inventory.item[1] = DiamondSword
Inventory.length[1] = 1 


CraftingTableSlots.length[1] = 0 
CraftingTableSlots.length[2] = 0 
CraftingTableSlots.length[3] = 0 
CraftingTableSlots.length[4] = 0 
CraftingTableSlots.length[5] = 0 
CraftingTableSlots.length[6] = 0 
CraftingTableSlots.length[7] = 0 
CraftingTableSlots.length[8] = 0 
CraftingTableSlots.length[9] = 0 
CraftingTableSlots.length[10] = 0 



recipies = {number = 10,list = {},CraftingTable = {} ,stick = {},plank = {},WoodPickaxeHead = {},stonePickaxeHead ={},IronPickaxeHead = {}, GoldPickaxeHead = {},DiamondPickaxeHead = {}, WoodAxeHead = {}, StoneAxeHead = {},IronAxeHead = {},GoldAxeHead = {},DiamondAxeHead = {}, WoodShovelHead = {}, StoneShovelHead = {}, IronShovelHead = {}, GoldShovelHead = {}, DiamondShovelHead = {},WoodPickaxe = {},StonePickaxe = {}, IronPickaxe = {},GoldPickaxe = {},DiamondPickaxe = {},WoodAxe = {},StoneAxe = {},IronAxe = {},GoldAxe = {},DiamondAxe = {},WoodShovel = {},StoneShovel = {}, IronShovel = {}, GoldShovel = {}, DiamondShovel = {}, IronPlate = {}, MachineBlock = {}, CopperWire = {}, ElectrumWire = {}, ElectronicCircut = {}, furnace = {}, ElectricFurnace = {},Grinder = {},Compressor = {},RunicAltar = {},Generator = {},Rune = {},SolarPanel = {}, Wrench = {},BlastFurnace ={},Coil = {},IronIngot ={},GoldIngot = {},CopperIngot ={},ElectrumIngot ={}, batteryBank = {},DiamondSwordBlade = {},DiamondSword = {} }

recipies.stick[1] = nil
recipies.stick[2] = nil
recipies.stick[3] = nil 
recipies.stick[4] = nil 
recipies.stick[5] = woodPlank 
recipies.stick[6] = nil
recipies.stick[7] = nil 
recipies.stick[8] = woodPlank
recipies.stick[9] = nil 
recipies.stick[10] = stick 
recipies.stick[11] = 4 

recipies.list[1] = stick 

recipies.plank[1] = PhysicsWood 
recipies.plank[2] = nil 
recipies.plank[3] = nil 
recipies.plank[4] = nil 
recipies.plank[5] = nil 
recipies.plank[6] = nil 
recipies.plank[7] = nil 
recipies.plank[8] = nil 
recipies.plank[9] = nil 
recipies.plank[10] = woodPlank
recipies.plank[11] = 4 
recipies.list[2] = plank

recipies.WoodPickaxeHead[1] = nil
recipies.WoodPickaxeHead[2] = woodPlank 
recipies.WoodPickaxeHead[3] = nil 
recipies.WoodPickaxeHead[4] = woodPlank
recipies.WoodPickaxeHead[5] = nil 
recipies.WoodPickaxeHead[6] = woodPlank
recipies.WoodPickaxeHead[7] = nil 
recipies.WoodPickaxeHead[8] = nil 
recipies.WoodPickaxeHead[9] = nil 
recipies.WoodPickaxeHead[10] = WoodPickaxeHead 
recipies.list[3] = WoodPickaxeHead

recipies.stonePickaxeHead[1] = nil
recipies.stonePickaxeHead[2] = stone
recipies.stonePickaxeHead[3] = nil 
recipies.stonePickaxeHead[4] = stone
recipies.stonePickaxeHead[5] = nil 
recipies.stonePickaxeHead[6] = stone
recipies.stonePickaxeHead[7] = nil 
recipies.stonePickaxeHead[8] = nil 
recipies.stonePickaxeHead[9] = nil 
recipies.stonePickaxeHead[10] = StonePickaxeHead 
recipies.list[4] = stonePickaxeHead

recipies.IronPickaxeHead[1] = nil
recipies.IronPickaxeHead[2] = IronIngot 
recipies.IronPickaxeHead[3] = nil 
recipies.IronPickaxeHead[4] = IronIngot
recipies.IronPickaxeHead[5] = nil 
recipies.IronPickaxeHead[6] = IronIngot
recipies.IronPickaxeHead[7] = nil 
recipies.IronPickaxeHead[8] = nil 
recipies.IronPickaxeHead[9] = nil 
recipies.IronPickaxeHead[10] = IronPickaxeHead
recipies.list[5] = IronPickaxeHead

recipies.GoldPickaxeHead[1] = nil
recipies.GoldPickaxeHead[2] = GoldIngot 
recipies.GoldPickaxeHead[3] = nil 
recipies.GoldPickaxeHead[4] = GoldIngot
recipies.GoldPickaxeHead[5] = nil 
recipies.GoldPickaxeHead[6] = GoldIngot
recipies.GoldPickaxeHead[7] = nil 
recipies.GoldPickaxeHead[8] = nil 
recipies.GoldPickaxeHead[9] = nil 
recipies.GoldPickaxeHead[10] = GoldPickaxeHead
recipies.list[6] = GoldPickaxeHead

recipies.DiamondPickaxeHead[1] = nil
recipies.DiamondPickaxeHead[2] = Diamond
recipies.DiamondPickaxeHead[3] = nil 
recipies.DiamondPickaxeHead[4] = Diamond
recipies.DiamondPickaxeHead[5] = nil 
recipies.DiamondPickaxeHead[6] = Diamond
recipies.DiamondPickaxeHead[7] = nil 
recipies.DiamondPickaxeHead[8] = nil 
recipies.DiamondPickaxeHead[9] = nil 
recipies.DiamondPickaxeHead[10] = DiamondPickaxeHead
recipies.list[7] = DiamondPickaxeHead

recipies.WoodAxeHead[1] = nil 
recipies.WoodAxeHead[2] = woodPlank 
recipies.WoodAxeHead[3] = woodPlank 
recipies.WoodAxeHead[4] = nil 
recipies.WoodAxeHead[5] = nil 
recipies.WoodAxeHead[6] = woodPlank
recipies.WoodAxeHead[7] = nil 
recipies.WoodAxeHead[8] = nil 
recipies.WoodAxeHead[9] = nil 
recipies.WoodAxeHead[10] = WoodAxeHead 
recipies.list[8] = WoodAxeHead

recipies.StoneAxeHead[1] = nil 
recipies.StoneAxeHead[2] = stone 
recipies.StoneAxeHead[3] = stone
recipies.StoneAxeHead[4] = nil 
recipies.StoneAxeHead[5] = nil 
recipies.StoneAxeHead[6] = stone
recipies.StoneAxeHead[7] = nil 
recipies.StoneAxeHead[8] = nil 
recipies.StoneAxeHead[9] = nil 
recipies.StoneAxeHead[10] = StoneAxeHead
recipies.list[9] = StoneAxeHead


recipies.IronAxeHead[1] = nil 
recipies.IronAxeHead[2] = IronIngot
recipies.IronAxeHead[3] = IronIngot
recipies.IronAxeHead[4] = nil 
recipies.IronAxeHead[5] = nil 
recipies.IronAxeHead[6] = IronIngot
recipies.IronAxeHead[7] = nil 
recipies.IronAxeHead[8] = nil 
recipies.IronAxeHead[9] = nil 
recipies.IronAxeHead[10] = IronAxeHead 
recipies.list[10] = IronAxeHead

recipies.GoldAxeHead[1] = nil 
recipies.GoldAxeHead[2] = GoldIngot
recipies.GoldAxeHead[3] = GoldIngot
recipies.GoldAxeHead[4] = nil 
recipies.GoldAxeHead[5] = nil 
recipies.GoldAxeHead[6] = GoldIngot
recipies.GoldAxeHead[7] = nil 
recipies.GoldAxeHead[8] = nil 
recipies.GoldAxeHead[9] = nil 
recipies.GoldAxeHead[10] = GoldAxeHead 
recipies.list[11] = GoldAxeHead

recipies.DiamondAxeHead[1] = nil 
recipies.DiamondAxeHead[2] = Diamond
recipies.DiamondAxeHead[3] = Diamond 
recipies.DiamondAxeHead[4] = nil 
recipies.DiamondAxeHead[5] = nil 
recipies.DiamondAxeHead[6] = Diamond
recipies.DiamondAxeHead[7] = nil 
recipies.DiamondAxeHead[8] = nil 
recipies.DiamondAxeHead[9] = nil 
recipies.DiamondAxeHead[10] = DiamondAxeHead
recipies.list[12] = DiamondAxeHead

recipies.WoodShovelHead[1] = nil 
recipies.WoodShovelHead[2] = woodPlank 
recipies.WoodShovelHead[3] = nil 
recipies.WoodShovelHead[4] = nil 
recipies.WoodShovelHead[5] = nil 
recipies.WoodShovelHead[6] = nil 
recipies.WoodShovelHead[7] = nil 
recipies.WoodShovelHead[8] = nil 
recipies.WoodShovelHead[9] = nil 
recipies.WoodShovelHead[10] = WoodShovelHead 
recipies.list[13] = WoodShovelHead

recipies.StoneShovelHead[1] = nil 
recipies.StoneShovelHead[2] = stone
recipies.StoneShovelHead[3] = nil 
recipies.StoneShovelHead[4] = nil 
recipies.StoneShovelHead[5] = nil 
recipies.StoneShovelHead[6] = nil 
recipies.StoneShovelHead[7] = nil 
recipies.StoneShovelHead[8] = nil 
recipies.StoneShovelHead[9] = nil 
recipies.StoneShovelHead[10] = StoneShovelHead
recipies.list[14] = StoneShovelHead

recipies.IronShovelHead[1] = nil 
recipies.IronShovelHead[2] = IronIngot 
recipies.IronShovelHead[3] = nil 
recipies.IronShovelHead[4] = nil 
recipies.IronShovelHead[5] = nil 
recipies.IronShovelHead[6] = nil 
recipies.IronShovelHead[7] = nil 
recipies.IronShovelHead[8] = nil 
recipies.IronShovelHead[9] = nil 
recipies.IronShovelHead[10] = IronShovelHead
recipies.list[15] = IronShovelHead

recipies.GoldShovelHead[1] = nil 
recipies.GoldShovelHead[2] = GoldIngot 
recipies.GoldShovelHead[3] = nil 
recipies.GoldShovelHead[4] = nil 
recipies.GoldShovelHead[5] = nil 
recipies.GoldShovelHead[6] = nil 
recipies.GoldShovelHead[7] = nil 
recipies.GoldShovelHead[8] = nil 
recipies.GoldShovelHead[9] = nil 
recipies.GoldShovelHead[10] = GoldShovelHead
recipies.list[16] = GoldShovelHead

recipies.DiamondShovelHead[1] = nil 
recipies.DiamondShovelHead[2] = Diamond 
recipies.DiamondShovelHead[3] = nil 
recipies.DiamondShovelHead[4] = nil 
recipies.DiamondShovelHead[5] = nil 
recipies.DiamondShovelHead[6] = nil 
recipies.DiamondShovelHead[7] = nil 
recipies.DiamondShovelHead[8] = nil 
recipies.DiamondShovelHead[9] = nil 
recipies.DiamondShovelHead[10] = DiamondShovelHead
recipies.list[17] = DiamondShovelHead

recipies.WoodPickaxe[5] = WoodPickaxeHead 
recipies.WoodPickaxe[8] = stick 
recipies.WoodPickaxe[10] = WoodPickaxe

recipies.StonePickaxe[5] = StonePickaxeHead
recipies.StonePickaxe[8] = stick 
recipies.StonePickaxe[10] = StonePickaxe

recipies.IronPickaxe[5] = IronPickaxeHead 
recipies.IronPickaxe[8] = stick 
recipies.IronPickaxe[10] = IronPickaxe

recipies.GoldPickaxe[5] = GoldPickaxeHead
recipies.GoldPickaxe[8] = stick 
recipies.GoldPickaxe[10] = GoldPickaxe

recipies.DiamondPickaxe[5] = DiamondPickaxeHead 
recipies.DiamondPickaxe[8] = stick
recipies.DiamondPickaxe[10] = DiamondPickaxe 

recipies.WoodShovel[5] = WoodShovelHead 
recipies.WoodShovel[8] = stick 
recipies.WoodShovel[10] = WoodShovel

recipies.StoneShovel[5] = StoneShovelHead 
recipies.StoneShovel[8] = stick 
recipies.StoneShovel[10] = StoneShovel

recipies.IronShovel[5] = IronShovelHead
recipies.IronShovel[8] = stick 
recipies.IronShovel[10] = IronShovel

recipies.GoldShovel[5] = IronShovelHead
recipies.GoldShovel[8] = stick 
recipies.GoldShovel[10] = GoldShovel

recipies.DiamondShovel[5] = DiamondShovelHead
recipies.DiamondShovel[8] = stick 
recipies.DiamondShovel[10] = DiamondShovel

recipies.WoodAxe[5] = WoodAxeHead
recipies.WoodAxe[8] = stick 
recipies.WoodAxe[10] = WoodAxe

recipies.StoneAxe[5] = StoneAxeHead 
recipies.StoneAxe[8] = stick 
recipies.StoneAxe[10] = StoneAxe

recipies.IronAxe[5] = IronShovelHead 
recipies.IronAxe[8] = stick 
recipies.IronAxe[10] = IronAxe

recipies.GoldAxe[5] = GoldShovelHead 
recipies.GoldAxe[8] = stick 
recipies.GoldAxe[10] = GoldAxe

recipies.DiamondAxe[5] =DiamondAxeHead
recipies.DiamondAxe[8] = stick 
recipies.DiamondAxe[10] = DiamondAxe

recipies.IronPlate[1] = IronIngot 
recipies.IronPlate[2] = IronIngot
recipies.IronPlate[4] = IronIngot 
recipies.IronPlate[5] = IronIngot 
recipies.IronPlate[10] = IronPlate

recipies.MachineBlock[1] = IronIngot 
recipies.MachineBlock[2] = IronIngot 
recipies.MachineBlock[3] = IronIngot 
recipies.MachineBlock[4] = IronIngot 
recipies.MachineBlock[6] = IronIngot 
recipies.MachineBlock[7] = IronIngot 
recipies.MachineBlock[8] = IronIngot 
recipies.MachineBlock[9] = IronIngot 
recipies.MachineBlock[10] = MachineBlock

recipies.furnace[1] = stone 
recipies.furnace[2] = stone 
recipies.furnace[3] = stone 
recipies.furnace[4] = stone
recipies.furnace[6] = stone 
recipies.furnace[7] = stone 
recipies.furnace[8] = stone 
recipies.furnace[9] = stone 
recipies.furnace[10] = furnace 

recipies.CopperWire[4] = CopperIngot 
recipies.CopperWire[5] = CopperIngot 
recipies.CopperWire[6] = CopperIngot
recipies.CopperWire[10] = CopperWire
recipies.CopperWire[11] = 6 

recipies.ElectrumWire[4] = ElectrumIngot
recipies.ElectrumWire[5] = ElectrumIngot
recipies.ElectrumWire[6] = ElectrumIngot
recipies.ElectrumWire[10] = ElectrumWire
recipies.ElectrumWire[11] = 6 

recipies.ElectronicCircut[1] = CopperWire 
recipies.ElectronicCircut[2] = CopperWire 
recipies.ElectronicCircut[3] = CopperWire 
recipies.ElectronicCircut[4] = ElectrumWire 
recipies.ElectronicCircut[5] = IronIngot 
recipies.ElectronicCircut[6] = ElectrumWire 
recipies.ElectronicCircut[7] = CopperWire 
recipies.ElectronicCircut[8] = CopperWire 
recipies.ElectronicCircut[9] = CopperWire 
recipies.ElectronicCircut[10] = ElectronicCircut

recipies.ElectricFurnace[4] = furnace 
recipies.ElectricFurnace[5] = ElectronicCircut 
recipies.ElectricFurnace[6] = furnace 
recipies.ElectricFurnace[7] = furnace 
recipies.ElectricFurnace[8] = MachineBlock  
recipies.ElectricFurnace[9] = furnace 
recipies.ElectricFurnace[10] = ElectricFurnace

recipies.Grinder[4] = IronIngot 
recipies.Grinder[5] = ElectronicCircut 
recipies.Grinder[6] = IronIngot 
recipies.Grinder[7] = IronIngot  
recipies.Grinder[8] = MachineBlock
recipies.Grinder[9] = IronIngot
recipies.Grinder[10] = Grinder 

recipies.Compressor[1] = stone 
recipies.Compressor[3] = stone 
recipies.Compressor[4] = stone 
recipies.Compressor[5] = ElectronicCircut 
recipies.Compressor[6] = stone 
recipies.Compressor[7] = stone 
recipies.Compressor[8] = MachineBlock 
recipies.Compressor[9] = stone 
recipies.Compressor[10] = Compressor

recipies.Generator[2]  = ElectronicCircut 
recipies.Generator[5] = furnace 
recipies.Generator[8] = MachineBlock
recipies.Generator[10] = Generator

recipies.Rune[2] = stone 
recipies.Rune[4] = stone 
recipies.Rune[6] = stone 
recipies.Rune[8] = stone 
recipies.Rune[10] = Rune


recipies.SolarPanel[1] = Glass 
recipies.SolarPanel[2] = Glass 
recipies.SolarPanel[3] = Glass 
recipies.SolarPanel[4] = CopperWire 
recipies.SolarPanel[5] = Diamond
recipies.SolarPanel[6] = CopperWire 
recipies.SolarPanel[7] = ElectronicCircut
recipies.SolarPanel[8] = MachineBlock 
recipies.SolarPanel[9] = ElectronicCircut

recipies.Wrench[1] = CopperIngot 
recipies.Wrench[3] = CopperIngot 
recipies.Wrench[4] = CopperIngot
recipies.Wrench[5] = CopperIngot
recipies.Wrench[6] = CopperIngot
recipies.Wrench[8] = CopperIngot
recipies.Wrench[10] = Wrench

recipies.Coil[1] = CopperWire 
recipies.Coil[2] = CopperWire
recipies.Coil[3] = CopperWire
recipies.Coil[4] = CopperWire
recipies.Coil[5] = IronIngot
recipies.Coil[6] = CopperWire
recipies.Coil[7] = CopperWire
recipies.Coil[8] = CopperWire
recipies.Coil[9] = CopperWire
recipies.Coil[10] = Coil

recipies.BlastFurnace[1] = Coil 
recipies.BlastFurnace[2] = MachineBlock
recipies.BlastFurnace[3] = Coil 
recipies.BlastFurnace[4] = MachineBlock 
recipies.BlastFurnace[5] = furnace 
recipies.BlastFurnace[6] = MachineBlock 
recipies.BlastFurnace[7] = Coil 
recipies.BlastFurnace[8] = MachineBlock 
recipies.BlastFurnace[9] = Coil 
recipies.BlastFurnace[10] = BlastFurnace

recipies.CraftingTable[1] = woodPlank
recipies.CraftingTable[2] = woodPlank
recipies.CraftingTable[4] = woodPlank
recipies.CraftingTable[5] = woodPlank
recipies.CraftingTable[10] = CraftingTable


recipies.IronIngot[1] = IronOre 
recipies.IronIngot[10] = IronIngot 
recipies.IronIngot[12] = Furnace 
recipies.IronIngot[13] = ElectricFurnace

recipies.GoldIngot[1] = GoldOre
recipies.GoldIngot[10] = GoldIngot 
recipies.GoldIngot[12] = Furnace 
recipies.GoldIngot[13] = ElectricFurnace 

recipies.ElectrumIngot[1] = ElectrumOre
recipies.ElectrumIngot[10] = ElectrumIngot
recipies.ElectrumIngot[12] = Furnace 
recipies.ElectrumIngot[13] = ElectricFurnace

recipies.CopperIngot[1] = CopperOre
recipies.CopperIngot[10] = CopperIngot
recipies.CopperIngot[12] = Furnace 
recipies.CopperIngot[13] = ElectricFurnace

recipies.batteryBank[1] = woodPlank
recipies.batteryBank[2] = CopperWire
recipies.batteryBank[3] = woodPlank
recipies.batteryBank[4] = CopperWire
recipies.batteryBank[5] = MachineBlock 
recipies.batteryBank[6] = CopperWire
recipies.batteryBank[7] = woodPlank
recipies.batteryBank[8] = CopperWire
recipies.batteryBank[9] = woodPlank
recipies.batteryBank[10] = BatteryBank

recipies.DiamondSwordBlade[2] = Diamond 
recipies.DiamondSwordBlade[6] = Diamond 
recipies.DiamondSwordBlade[10] = DiamondSwordBlade

recipies.DiamondSword[6] = DiamondSwordBlade
recipies.DiamondSword[8] = stick 
recipies.DiamondSword[10] = DiamondSword 



end--ends function love.load()

function love.update(dt)


local StartCharacterX = CharacterX
local StartCharacterY = CharacterY 
--These are used to see if the character has moved, and move any mobs so that they dont move with the character. The position of mobs is it's position on the screen. 

FindMachine()

PowerStorage()
CloseMachines()

local StartPos = math.floor(CharacterY/25-5000/25)
local XPosOfCharacter = PosOfCharacter+CharacterX/25+340

 StartOfLoop = 1 
 EndOfLoop = PosOfCharacter+CharacterX/25-WidthOfWorld*5-200+3000-1100+100

PosOfCharacter = StartPos*WidthOfWorld+15*WidthOfWorld
if PosOfCharacter+CharacterX/25-WidthOfWorld*5-200+3000-1100>0 then 
 StartOfLoop = PosOfCharacter+CharacterX/25-WidthOfWorld*5-200+3000-800

end 

for i = EndOfLoop,StartOfLoop do 
BlockImage.blackened[i] = false 
--BlockImage[i] = ElectricFurnace
end 

--BlockImage[PosOfCharacter+CharacterX/25+340] =ElectricFurnace




if love.mouse.isDown('r') == true then 
WireOrientation()
end 


for i = 1,NumberOfWires do 
Wire(i)
end 

local machineBeingRun = 0 

for i = 1,#Inventories.machines.machineType do 
machineBeingRun = machineBeingRun+1 
Machine(machineBeingRun)
end 

for i = 1,#Inventories.generators.power do 

GeneratorFunction(i)

if BlockImage[Inventories.generators.pos[i]] ~= Generator and BlockImage[Inventories.generators.pos[i]] ~= SolarPanel then 
Inventories.generators.pos[i] = 0 
Inventories.generators.power[i] = 0 
Inventories.generators.slot1[i] = nil 
end 
end 

for i = 1,#Inventories.machines.power do 
if BlockImage[Inventories.machines.pos[i]] ~= ElectricFurnace and  BlockImage[Inventories.machines.pos[i]] ~= Grinder and  BlockImage[Inventories.machines.pos[i]] ~= Compresor and BlockImage[Inventories.machines.pos[i]] ~= BlastFurnace  then 
Inventories.machines.pos[i] = 0 
Inventories.machines.power[i] = 0 
Inventories.machines.slot1[i] = nil 
Inventories.machines.slot2[i] = nil 
Inventories.machines.counter[i] = nil 
end 
end 

for i = 1,#Inventories.Wire.pos do 
if BlockImage[Inventories.Wire.pos[i]] ~= CopperWire then 
Inventories.Wire.pos[i] = 0
Inventories.Wire.power[i] = 0
Inventories.Wire.orientation[i] = 100
end 
end 


InsertIntoGenerator()


ClearInventories()


jumpParticles:update(dt)
magicToolParticles:update(dt)
MagicParticles:update(dt)
SwordParticles:update(dt)

if breakParticles ~= nil then 
breakParticles:update(dt)
end 


PlayerHealth()
DragItems()

InsertIntoMachine()
--GeneratorFunction() 
 
Furnace()

RunicAltarFunction()

Trinkets()

DrawBlockSelected()


local StartOfLoop = 1 
local StartOfLoop = PosOfCharacter-10*WidthOfWorld

RectX = -25
RectY = -25
local blackenedCounter = 0 
for i = 1,10 do 
blackenedCounter = blackenedCounter+1 
BlockImage.blackened[XPosOfCharacter+blackenedCounter] = false 
end 

for i = StartOfLoop, PosOfCharacter+5*WidthOfWorld do --#BlockImage

if BlockImage[i] == RunicAltar then 
if love.math.random(1,50) == 1 then 
MagicParticles:emit(1)
end 
local xSpeed = love.math.random(-100,100)
local ySpeed = love.math.random(-100,100)
MagicParticles:setSpin(2,3)
MagicParticles:setOffset(10,10)
MagicParticles:setTangentialAcceleration(5,10)
MagicParticles:setLinearAcceleration(xSpeed,ySpeed)
magicParticleX = BlocksX[i]*Scale-CharacterX+5000
magicParticleY = BlocksY[i]*Scale-CharacterY+200+5000
end 


GrowPlants()



if love.mouse.isDown('r') == true and PosOfCharacter ~= nil then 
PlaceBlocks(i)
end 
if love.mouse.isDown('l') == true and PosOfCharacter ~= nil then 
BreakBlocks(i)
end 


end 





ChooseInventorySlot()



if jumping == true then 
jumpCounter = jumpCounter+1 
if jumpCounter<HeightOfJump then 
local fallspeed = HeightOfJump-jumpCounter
CharacterY = CharacterY- fallspeed
else 
jumpCounter = 0 
NumberOfJumps = NumberOfJumps-1 
if NumberOfJumps == 0 then 
jumping = false 
end 

end

end 




entity()

SwingSword()




if love.keyboard.isDown('e') then
if InventoryOpened == false then 
if InventoryCounter~=10 then 
InventoryCounter = InventoryCounter+1 
else 
InventoryOpened = true 
InventoryCounter = 0 
end
else
if InventoryCounter == 10 then 
InventoryOpened = false 
InventoryCounter = 0 
else 
InventoryCounter = InventoryCounter+1 
end 
end 
end


if InventoryOpened == true then
DrawInventory()
end


if FurnaceOpened == true then 
ElectricFurnaceOpened = false 
GeneratorOpened = false 
elseif ElectricFurnaceOpened == true then 
FurnaceOpened = false 
GeneratorOpened = false 
elseif GeneratorOpened == true then 
FurnaceOpened = false 
ElectricFurnaceOpened = false 
end 





NewMobFunction()


DealDamageToPlayer()
DealDamageToMob()
CleanupMobs()
SpawnMobs()

local SpawnMob = false 
SpawnCounter = SpawnCounter+1 
if SpawnCounter == 100 then 
SpawnCounter = 0 
SpawnMob = true 
end 


local StartPos = 0+CharacterY/25-5000/25 
PosOfCharacter = StartPos*WidthOfWorld+15*WidthOfWorld


if StartCharacterX ~= CharacterX  then 
for i = 1,#Mobs.posX do 
if Mobs.posX[i] ~= nil then 
Mobs.posX[i] = Mobs.posX[i]-CharacterX+StartCharacterX 
end 
end 
end 

if StartCharacterY ~= CharacterY  then 
for i = 1,#Mobs.posY do 
if Mobs.posY[i ] ~= nil then 
Mobs.posY[i] = Mobs.posY[i]-CharacterY+StartCharacterY
end 
end 
end 



end --ends function love.update()


function DrawBlockSelected()
if BlocksX[i]~= nil and BlocksY[i]~= nil then 
if x>BlocksX[i]*Scale-CharacterX+5000 and x<BlocksX[i]*Scale-CharacterX+5000+25 and y>BlocksY[i]*Scale-CharacterY+200+5000 and y<BlocksY[i]*Scale-CharacterY+200+5000+25 and BlockImage[i] ~= 0 then 
if BlockImage[i] ~= 0 then 
RectX = BlocksX[i]*Scale-CharacterX+5000
RectY = BlocksY[i]*Scale-CharacterY+200+5000
end
end
end 
end 
function CloseMachines()
if love.keyboard.isDown('a') == true or love.keyboard.isDown('w') == true or love.keyboard.isDown('s') == true or love.keyboard.isDown('d') == true then 
FurnaceOpened = false 
ElectricFurnaceOpened = false 
GeneratorOpened = false 
GrinderOpened = false 
CompressorOpened = false 
BatteryBankBeingOpened = 0 
CraftingTableOpened = false 
RunicAltarOpened = false 
BlastFurnaceOpened = false 
end 

end 
function GrowPlants()
if BlockImage[i] == leaf then 
local RowCounter = 0 
local ColumnCounter = -3 
local PosCheckWood = 0 
local PosOfLeaf = 0 
local WoodFound = false 
PosOfLeaf = i 
for i = 1,10 do 
RowCounter = RowCounter+WidthOfWorld  
ColumnCounter = -3 
for i = 1,7 do 
ColumnCounter = ColumnCounter+1 
if BlockImage[PosOfLeaf+ColumnCounter+RowCounter] == wood then 
WoodFound = true 
end 
end 
end 
if WoodFound == false and love.math.random(1,300) == 1 then 
BlockImage[PosOfLeaf] = 0 
end 
end 




if BlockImage[i] == grass and BlockImage[i+1] == dirt and love.math.random(0,500) == 0 and BlockImage[i+201] == 0  then
BlockImage[i+1] = grass
end

if BlockImage[i] == grass and BlockImage[i+201] == dirt and love.math.random(0,500) == 0 and BlockImage[i+1] == 0 then
BlockImage[i+201] = grass
end

if BlockImage[i] == grass and BlockImage[i+199] == dirt and love.math.random(0,500) == 0 and BlockImage[i+1] == 0 then
BlockImage[i+199] = grass
end 

if BlockImage[i] == grass and BlockImage[i-200] ~= 0 and love.math.random(0,500) == 0 and BlockImage[i-200] ~= wood and BlockImage[i-200] ~= Character then
BlockImage[i] = dirt
end

if BlockImage[i] == Seeds and love.math.random(1,5000) == 1 then 
BlockImage[i] = Wheat
end 
end 
function ClearInventories()
if love.keyboard.isDown('x') then 
BreakBlockCounter = 0 
if CraftingTableSlots[1] ~= nil then 
for i = 1, CraftingTableSlots.length[1] do 
InsertItem(CraftingTableSlots[1])
end 
end 

if CraftingTableSlots[2] ~= nil then 
for i = 1, CraftingTableSlots.length[2] do 
InsertItem(CraftingTableSlots[2])
end 
end 

if CraftingTableSlots[3] ~= nil then  
for i = 1, CraftingTableSlots.length[3] do 
InsertItem(CraftingTableSlots[3])
end 
end 

if CraftingTableSlots[4] ~= nil then 
for i = 1, CraftingTableSlots.length[4] do 
InsertItem(CraftingTableSlots[4])
end 
end 

if CraftingTableSlots[5] ~= nil then 
for i = 1, CraftingTableSlots.length[5] do 
InsertItem(CraftingTableSlots[5])
end 
end 


if CraftingTableSlots[6] ~= nil then  
for i = 1, CraftingTableSlots.length[6] do 
InsertItem(CraftingTableSlots[6])
end 
end 

if CraftingTableSlots[7] ~= nil then 
for i = 1, CraftingTableSlots.length[7] do 
InsertItem(CraftingTableSlots[7])
end 
end 

if CraftingTableSlots[8] ~= nil then  
for i = 1, CraftingTableSlots.length[8] do 
InsertItem(CraftingTableSlots[8])
end 
end 

if CraftingTableSlots[9] ~= nil then 
for i = 1, CraftingTableSlots.length[9] do 
InsertItem(CraftingTableSlots[9])
end 
end 

if Inventories.machines.slot1[MachineBeingOpened] ~= nil and Inventories.machines.length1[MachineBeingOpened] ~= 0 and ElectricFurnaceOpened == true or GrinderOpened == true or CompressorOpened == true then 
for i = 1, Inventories.machines.length1[MachineBeingOpened] do 
InsertItem(Inventories.machines.slot1[MachineBeingOpened])
end 
end 

if Inventories.machines.slot2[MachineBeingOpened] ~= nil and Inventories.machines.length2[MachineBeingOpened] ~= 0 and ElectricFurnaceOpened == true or GrinderOpened == true or CompressorOpened == true then 
for i = 1, Inventories.machines.length2[MachineBeingOpened] do 
InsertItem(Inventories.machines.slot2[MachineBeingOpened])
end 
end 
Inventories.machines.slot1[MachineBeingOpened] = nil 
Inventories.machines.slot2[MachineBeingOpened] = nil 
Inventories.machines.length1[MachineBeingOpened] = 0 
Inventories.machines.length2[MachineBeingOpened] = 0 


if Inventories.furnaces.slot1[FurnaceBeingOpened] ~= nil and Inventories.furnaces.length1[FurnaceBeingOpened] ~= 0 and FurnaceOpened == true then 
for i = 1, Inventories.furnaces.length1[FurnaceBeingOpened] do 
InsertItem(Inventories.furnaces.slot1[FurnaceBeingOpened])
end 
end 

if ElectricFurnaceInventory[1] ~= nil and ElectricFurnaceInventory.length[1] ~= 0 and ElectricFurnaceOpened == true then 
for i = 1,ElectricFurnaceInventory.length[1] do 
InsertItem(ElectricFurnaceInventory[1])
end 
end 

if Inventories.furnaces.slot2[FurnaceBeingOpened] ~= nil and FurnaceBeingOpened == true then 
for i = 1,Inventories.furnaces.slot2[FurnaceBeingOpened] do 
InsertItem(FurnaceInventory[2])
end 
end 

CraftingTableSlots[1] = nil 
CraftingTableSlots.length[1] = 0 
CraftingTableSlots[2] = nil 
CraftingTableSlots.length[2] = 0 
CraftingTableSlots[3] = nil 
CraftingTableSlots.length[3] = 0 
CraftingTableSlots[4] = nil 
CraftingTableSlots.length[4] = 0 
CraftingTableSlots[5] = nil
CraftingTableSlots.length[5] = 0 
CraftingTableSlots[6] = nil 
CraftingTableSlots.length[6] = 0 
CraftingTableSlots[7] = nil 
CraftingTableSlots.length[7] = 0 
CraftingTableSlots[8] = nil 
CraftingTableSlots.length[8] = 0 
CraftingTableSlots[9] = nil 
CraftingTableSlots.length[9] = 0 
CraftingTableSlots[10] = nil
CraftingTableSlots.length[10] = 0 

Inventories.furnaces.slot1[FurnaceBeingOpened] = nil 
Inventories.furnaces.length1[FurnaceBeingOpened] = 0
Inventories.furnaces.counter[FurnaceBeingOpened] = nil 

Inventories.furnaces.slot2[FurnaceBeingOpened] = nil 
Inventories.furnaces.length2[FurnaceBeingOpened] = 0 
Inventories.furnaces.counter[FurnaceBeingOpened] = 0 

FurnaceInventory[1] = nil 
FurnaceInventory.length[1] = 0 
FurnaceCookingCounter = 0 

FurnaceInventory[2] = nil 
ElectricFurnaceInventory.length[1]  = 0 
ElectricFurnaceInventory[1] = nil 

if Inventories.grinder.slot1[GrinderBeingOpened]~= nil and GrinderOpened == true then 
for i = 1, Inventories.grinder.length1[GrinderBeingOpened] do 
InsertItem(Inventories.grinder.slot1[GrinderBeingOpened])
end 
Inventories.grinder.slot1[GrinderBeingOpened] = nil 
Inventories.grinder.length1[GrinderBeingOpened] = 0 

end 

if Inventories.grinder.slot2[GrinderBeingOpened] ~= nil and GrinderOpened == true then 
for i = 1, Inventories.grinder.length2[GrinderBeingOpened] do 
InsertItem(Inventories.grinder.slot2[GrinderBeingOpened])
end 
Inventories.grinder.slot2[GrinderBeingOpened] = nil 
Inventories.grinder.length2[GrinderBeingOpened] = 0 
end 
end 

end 


function Trinkets()

MaxJumps = 1 
HeightOfJump = 15 
Visible = true 
local x = love.mouse.getX()
local y = love.mouse.getY()
if love.mouse.isDown('r') == true then 

if x>100 and x<200 and y>400 and y<500 and Inventory.item[EquippedItem] ~= nil and Inventories.trinketSlots[1] == nil then 
Inventories.trinketSlots[1] = Inventory.item[EquippedItem]
RemoveItem(EquippedItem)
end 

end 

if love.mouse.isDown('l') == true then 
if x>100 and x<200 and y>400 and y<500 and Inventories.trinketSlots[1] ~= nil then 
InsertItem(Inventories.trinketSlots[1])
Inventories.trinketSlots[1] = nil 
end 
end 


if Inventories.trinketSlots[1] == DoubleJumpPendant then 
MaxJumps = 2 
HeightOfJump = 18
end 
if Inventories.trinketSlots[1] == HighJumpPendant then 
HeightOfJump = 20
end 

if Inventories.trinketSlots[1] == InvisibilityPendant and love.keyboard.isDown('tab') == true then 
Visible = false 
end 

end 

function FindMachine()
local WirePos = 0 
local machineUp = false 
local machineDown = false 
local machineLeft = false 
local machineRight = false 
local BatteryBankNumber = 0 

local OffsetOfWire = 0 

local WireCounter = 0 

for i = 1,#Inventories.batteryBank.pos do 
WireCounter = WireCounter+1 


if BlockImage[Inventories.batteryBank.pos[i]+1] == CopperWire then 
BatteryBankNumber = i
WirePos = Inventories.batteryBank.pos[i]+1 
OffsetOfWire = OffsetOfWire+1 
end 


if BlockImage[Inventories.batteryBank.pos[i]-1] == CopperWire then 
BatteryBankNumber = i 
WirePos = Inventories.batteryBank.pos[i]-1 
end 
if BlockImage[Inventories.batteryBank.pos[i]-WidthOfWorld] == CopperWire then 
BatteryBankNumber = i 
WirePos = Inventories.batteryBank.pos[i]-WidthOfWorld 
end 
if BlockImage[Inventories.batteryBank.pos[i]+WidthOfWorld] == CopperWire then 
BatteryBankNumber = i 
WirePos = Inventories.batteryBank.pos[i]+WidthOfWorld 
end 

end 

if BlockImage[WirePos+1] == ElectricFurnace or BlockImage[WirePos+1] == Grinder or BlockImage[WirePos+1] == Compresor or BlockImage[WirePos+1] == BlastFurnace then 
machineRight = true 
OffsetOfWire = 1
end 

if BlockImage[WirePos-1] == ElectricFurnace or BlockImage[WirePos-1] == Grinder or BlockImage[WirePos-1] == Compresor or BlockImage[WirePos+1] == BlastFurnace then 
machineLeft = true 
end 

if BlockImage[WirePos+WidthOfWorld] == ElectricFurnace or BlockImage[WirePos+WidthOfWorld] == Grinder or BlockImage[WirePos+WidthOfWorld] == Compresor or BlockImage[WirePos+1] == BlastFurnace then 
machineDown = true 
end 

if BlockImage[WirePos-WidthOfWorld] == ElectricFurnace or BlockImage[WirePos-WidthOfWorld] == Grinder or BlockImage[WirePos-WidthOfWorld] == Compresor or BlockImage[WirePos+1] == BlastFurnace then 
machineUp = true  
end 


if BlockImage[WirePos+1+OffsetOfWire] == ElectricFurnace or BlockImage[WirePos+1+OffsetOfWire] == Grinder or BlockImage[WirePos+1+OffsetOfWire] == Compresor or BlockImage[WirePos+1] == BlastFurnace then 
machineRight = true 
OffsetOfWire =  OffsetOfWire+1 
end 




if machineRight == true then 
for i = 1,#Inventories.machines.pos do 
if Inventories.machines.pos[i] == WirePos+OffsetOfWire and Inventories.batteryBank.power[BatteryBankNumber]>0 then 
--Inventories.machines.power[i] = Inventories.machines.power[i]+OffsetOfWire 
--Inventories.batteryBank.power[BatteryBankNumber] = Inventories.batteryBank.power[BatteryBankNumber]-1 
end--ends if Inventories.machines.pos[i] ==WirePos+1 then 
end --ends for i = 1,#Inventories.machines.pos 
end --ends if machineRight == true then 

if machineLeft == true then 
for i = 1,#Inventories.machines.pos do 
if Inventories.machines.pos[i] == WirePos-1 and Inventories.batteryBank.power[BatteryBankNumber]>0 then 
--Inventories.machines.power[i] = Inventories.machines.power[i]+1 
--Inventories.batteryBank.power[BatteryBankNumber] = Inventories.batteryBank.power[BatteryBankNumber]-1 
end--ends if Inventories.machines.pos[i] ==WirePos+1 then 
end --ends for i = 1,#Inventories.machines.pos 
end --ends if machineRight == true then 

if machineUp == true then 
for i = 1,#Inventories.machines.pos do 
if Inventories.machines.pos[i] == WirePos-WidthOfWorld and Inventories.batteryBank.power[BatteryBankNumber]>0 then 
--Inventories.machines.power[i] = Inventories.machines.power[i]+1 
--Inventories.batteryBank.power[BatteryBankNumber] = Inventories.batteryBank.power[BatteryBankNumber]-1 
end--ends if Inventories.machines.pos[i] ==WirePos+1 then 
end --ends for i = 1,#Inventories.machines.pos 
end --ends if machineRight == true then 

if machineDown == true then 
for i = 1,#Inventories.machines.pos do 
if Inventories.machines.pos[i] == WirePos+WidthOfWorld and Inventories.batteryBank.power[BatteryBankNumber]>0 then 
--Inventories.machines.power[i] = Inventories.machines.power[i]+1 
--Inventories.batteryBank.power[BatteryBankNumber] = Inventories.batteryBank.power[BatteryBankNumber]-1 
end--ends if Inventories.machines.pos[i] ==WirePos+1 then 
end --ends for i = 1,#Inventories.machines.pos 
end --ends if machineRight == true then 

end 


function Machine(machineBeingRun)

if Inventories.machines.length1[machineBeingRun] == 0 then 
Inventories.machines.slot1[machineBeingRun] = nil 
end 

if Inventories.machines.length2[machineBeingRun] == 0 then 
Inventories.machines.slot2[machineBeingRun] = nil 
end 


local SmeltItem = false 

if Inventories.machines.machineType[machineBeingRun] == ElectricFurnace then 

if Inventories.machines.slot1[machineBeingRun] == IronOre or Inventories.machines.slot1[machineBeingRun] == IronDust or Inventories.machines.slot1[machineBeingRun] == GoldOre or Inventories.machines.slot1[machineBeingRun] == GoldDust or Inventories.machines.slot1[machineBeingRun] == CopperOre or Inventories.machines.slot1[machineBeingRun] == CopperDust or Inventories.machines.slot1[machineBeingRun] == ElectrumOre or Inventories.machines.slot1[machineBeingRun] == ElectrumDust or Inventories.machines.slot1[machineBeingRun] == Flour or Inventories.machines.slot1[machineBeingRun] == Sand then 

Inventories.machines.counter[machineBeingRun] = Inventories.machines.counter[machineBeingRun]+1 
Inventories.machines.power[machineBeingRun] = Inventories.machines.power[machineBeingRun]-1 

if Inventories.machines.counter[machineBeingRun]== 100  then 

Inventories.machines.counter[machineBeingRun] = 0 

if Inventories.machines.slot1[machineBeingRun] == IronOre or Inventories.machines.slot1[machineBeingRun] == IronDust then 
Inventories.machines.slot2[machineBeingRun] = IronIngot 
SmeltItem = true 
elseif Inventories.machines.slot1[machineBeingRun] == GoldOre or Inventories.machines.slot1[machineBeingRun] == GoldDust then 
Inventories.machines.slot2[machineBeingRun] = GoldIngot
SmeltItem = true 
elseif Inventories.machines.slot1[machineBeingRun] == CopperOre or Inventories.machines.slot1[machineBeingRun] == CopperDust then 
Inventories.machines.slot2[machineBeingRun] = CopperIngot
SmeltItem = true 
elseif Inventories.machines.slot1[machineBeingRun] == ElectrumOre or Inventories.machines.slot1[machineBeingRun] == ElectrumDust then 
Inventories.machines.slot2[machineBeingRun] = ElectrumIngot
SmeltItem = true 
elseif Inventories.machines.slot1[machineBeingRun] == Flour then 
Inventories.machines.slot2[machineBeingRun] = Bread 
SmeltItem = true 
elseif Inventories.machines.slot1[machineBeingRun] == Sand then 
Inventories.machines.slot2[machineBeingRun] = Glass 
SmeltItem = true 
end 


if SmeltItem == true then 

Inventories.machines.length2[machineBeingRun] = Inventories.machines.length2[machineBeingRun]+1 

Inventories.machines.length1[machineBeingRun] = Inventories.machines.length1[machineBeingRun]-1 
if Inventories.machines.length1[machineBeingRun] == 0 then 
Inventories.machines.slot1[machineBeingRun] = nil 
end 

end--ends if Inventories.machines.power[machineBeingRun]>100 then...

end--ends if SmeltItem == true then 

end--ends if Inventories.machines.slot1[machineBeingRun] == Ironore or ...

end --ends if Inventories.machines.machineType...

local GrindItem = false 

if Inventories.machines.machineType[machineBeingRun] == Grinder and Inventories.machines.power[machineBeingRun]>0 then 
if Inventories.machines.slot1[machineBeingRun] == IronOre or Inventories.machines.slot1[machineBeingRun] == GoldOre or Inventories.machines.slot1[machineBeingRun] == CopperOre or Inventories.machines.slot1[machineBeingRun] == ElecrumOre or Inventories.machines.slot1[machineBeingRun] == stone  then 


--if Inventories.machines.power[machineBeingRun]>200 then 
--Inventories.machines.power[machineBeingRun] = Inventories.machines.power[machineBeingRun]-100 

if Inventories.machines.slot1[machineBeingRun] == IronOre then 
Inventories.machines.slot2[machineBeingRun] = IronDust
GrindItem = true 
elseif Inventories.machines.slot1[machineBeingRun] == GoldOre then 
Inventories.machines.slot2[machineBeingRun] = GoldDust 
GrindItem = true 
elseif Inventories.machines.slot1[machineBeingRun] == CopperOre then 
Inventories.machines.slot2[machineBeingRun] = CopperDust 
GrindItem = true 
elseif Inventories.machines.slot1[machineBeingRun] == ElectrumOre then 
Inventories.machines.slot2[machineBeingRun] = ElectrumDust 
GrindItem = true 
elseif Inventories.machines.slot1[machineBeingRun] == stone then 
Inventories.machines.slot2[machineBeingRun] = Sand 
GrindItem = true 
--end 
end 


if GrindItem == true then 
Inventories.machines.counter[machineBeingRun] = Inventories.machines.counter[machineBeingRun]+1 
Inventories.machines.power[machineBeingRun] = Inventories.machines.power[machineBeingRun]-1 
if Inventories.machines.counter[machineBeingRun] == 100 then 
Inventories.machines.counter[machineBeingRun] = 0 

Inventories.machines.length1[machineBeingRun] = Inventories.machines.length1[machineBeingRun]-1 
Inventories.machines.length2[machineBeingRun] = Inventories.machines.length2[machineBeingRun]+2 

if Inventories.machines.length1[machineBeingRun] == 0 then 
Inventories.machines.slot1[machineBeingRun] = nil 
end 

end 

end --ends if GrindItem == true then... 

end 


end--ends if Inventories.machines,machineType[machineBeingRun] == Grinder then...

if Inventories.machines.machineType[machineBeingRun] == Compressor and Inventories.machines.length1[machineBeingRun] >=2 then 

if Inventories.machines.slot1[machineBeingRun] == IronIngot and Inventories.machines.power[machineBeingRun]>1 then 
Inventories.machines.counter[machineBeingRun] = Inventories.machines.counter[machineBeingRun]+1 
Inventories.machines.power[machineBeingRun] = Inventories.machines.power[machineBeingRun]-1 

if Inventories.machines.counter[machineBeingRun] == 100 then 
Inventories.machines.counter[machineBeingRun] = 0 


Inventories.machines.length2[machineBeingRun] = Inventories.machines.length2[machineBeingRun]+2
Inventories.machines.slot2[machineBeingRun] = IronPlate 

Inventories.machines.length1[machineBeingRun] = Inventories.machines.length1[machineBeingRun]-2

if Inventories.machines.length1[machineBeingRun] == 0 then 
Inventories.machines.slot1[machineBeingRun] = nil 
end 
end 
end 

end 

if Inventories.machines.machineType[machineBeingRun] == BlastFurnace and Inventories.machines.power[machineBeingRun]>4 then 

if Inventories.machines.slot1[machineBeingRun] == IronIngot then 

Inventories.machines.counter[machineBeingRun] = Inventories.machines.counter[machineBeingRun]+1 
Inventories.machines.power[machineBeingRun] = Inventories.machines.power[machineBeingRun]-4 

if Inventories.machines.counter[machineBeingRun] == 1000 then 
Inventories.machines.counter[machineBeingRun] = 0 

Inventories.machines.slot2[machineBeingRun] = SteelIngot
Inventories.machines.length2[machineBeingRun] = Inventories.machines.length2[machineBeingRun]+1 

Inventories.machines.length1[machineBeingRun] = Inventories.machines.length1[machineBeingRun]-1 



if Inventories.machines.length1[machineBeingRun] == 0 then 
Inventories.machines.slot1[machineBeingRun] = nil 
end 
end 
end 
end 

end 
function InsertIntoMachine()
if love.mouse.isDown('r') == true then 
 x = love.mouse.getX()
 y = love.mouse.getY()
local PressSlot1 = false 
local PressSlot2 = false 

if Inventories.machines.length1[MachineBeingOpened]== 0 then 
Inventories.machines.slot1[MachineBeingOpened] = nil 
end 
if Inventories.machines.length2[MachineBeingOpened] == 0 then 
Inventories.machines.slot2[MachineBeingOpened] = nil 
end 

if x>1000 and x<1100 and y>200 and y>300 then 
PressSlot1 = true 
--Inventories.machines.slot1[MachineBeingOpened] = stone 
--Inventories.machines.length1[MachineBeingOpened] = 10 
end 

if x>1100 and x<1200 and y>300 and y<400 then 
PressSlot2 = true 
end 

if PressSlot1 == true and Inventory.item[EquippedItem] ~= nil and Inventory.length[EquippedItem] ~= 0 and ElectricFurnaceOpened == true or GrinderOpened == true or CompresorOpened == true or BlastFurnaceOpened == true then --This code is used to insert an item into the first slot of the grinder
if Inventories.machines.length1[MachineBeingOpened] == 0 or Inventories.machines.slot1[MachineBeingOpened] == Inventory.item[EquippedItem] then 
InsertItemCounter = InsertItemCounter+1 

if InsertItemCounter == 5 then 
InsertItemCounter = 0 

Inventories.machines.slot1[MachineBeingOpened] = Inventory.item[EquippedItem]
Inventories.machines.length1[MachineBeingOpened] = Inventories.machines.length1[MachineBeingOpened]+1 
Inventory.length[EquippedItem] = Inventory.length[EquippedItem]-1 

end --ends if InsertItemCounter == 5 then 

end 
end 


if PressSlot2 == true and Inventories.machines.slot2[MachineBeingOpened] ~= nil and Inventories.machines.length2[MachineBeingOpened] ~= nil then --This code is used to take out an item from the second slot
InsertItemCounter = InsertItemCounter+1 
if InsertItemCounter == 5 then 
InsertItemCounter = 0 

InsertItem(Inventories.machines.slot2[MachineBeingOpened])
 Inventories.machines.length2[MachineBeingOpened] = Inventories.machines.length2[MachineBeingOpened]-1 

if Inventories.machines.length2[MachineBeingOpened]<= 0 then 
Inventories.machines.slot2[MachineBeingOpened] = nil 
end 

end-- ends if InsertItemCounter

end --ends if PressGrinderSlot2 == true...

end--ends if love.mouse.isDown("r") == true and...

--Inventories.machines.slot1[MachineBeingOpened] = stone
--Inventories.machines.length1[MachineBeingOpened] = 10 

if Inventories.machines.length1[MachineBeingOpened] == 0 then 
Inventories.machines.slot1[MachineBeingOpened] = nil 
end 
if Inventories.machines.length2[MachineBeingOpened] == 0 then 
Inventories.machines.slot2[MachineBeingOpened] = nil 
end 

if Inventory.length[EquippedItem] == 0 then --These lines are making sure that no items are being inserted or taken out of the grinder if the length of the item's stack is 0 
Inventory.item[EquippedItem] = nil 
end 


end 
function DrawMachine()
if ElectricFurnaceOpened == true or GrinderOpened == true or CompressorOpened == true or BlastFurnaceOpened == true then 
love.graphics.setColor(200,200,200)
love.graphics.rectangle("line",1000,300,100,100)
love.graphics.rectangle("line",1100,300,100,100)
if Inventories.machines.slot1[MachineBeingOpened] then 
love.graphics.draw(Inventories.machines.slot1[MachineBeingOpened],1000,300,0,3)
love.graphics.print(Inventories.machines.length1[MachineBeingOpened],1000,300)
--love.graphics.print(GrindProgress .. " /100",1000,280)
end 
if Inventories.machines.slot2[MachineBeingOpened] then 
love.graphics.draw(Inventories.machines.slot2[MachineBeingOpened],1100,300,0,3)
love.graphics.print(Inventories.machines.length2[MachineBeingOpened],1100,300)
end 

if Inventories.machines.power[MachineBeingOpened]~= nil  then 
love.graphics.print(Inventories.machines.power[MachineBeingOpened] .. " EU",1200,300)
else 
love.graphics.print(":( ",1200,300)
end 
if Inventories.machines.counter[MachineBeingOpened] ~= nil and Inventories.machines.machineType ~= BlastFurnace[MachineBeingOpened] then 
love.graphics.print(Inventories.machines.counter[MachineBeingOpened].." /100",1000,280)
end 
if Inventories.machines.counter[MachineBeingOpened] ~= nil and Inventories.machines.machineType[MachineBeingOpened] == BlastFurnace then 
love.graphics.print(Inventories.machines.counter[MachineBeingOpened].." /1000",1000,280)
end 

love.graphics.setColor(255,255,255)
end 


end 


function PowerStorage()
local batteryBankCheck  = 0 
for i = 1,#Inventories.batteryBank.power do 
batteryBankCheck = batteryBankCheck+1 
if Inventories.batteryBank.power[batteryBankCheck] ~= nil then 

for i = 1,#Inventories.machines.pos do 

if Inventories.batteryBank.pos[batteryBankCheck] == Inventories.machines.pos[i]+1 and Inventories.batteryBank.power[batteryBankCheck]>0 and Inventories.machines.power[i]<3000 then 
Inventories.machines.power[i] = Inventories.machines.power[i]+1 
Inventories.batteryBank.power[batteryBankCheck] = Inventories.batteryBank.power[batteryBankCheck]-1 
end 

if Inventories.batteryBank.pos[batteryBankCheck] == Inventories.machines.pos[i]-1 and Inventories.batteryBank.power[batteryBankCheck]>0 and Inventories.machines.power[i]<3000 then 
Inventories.machines.power[i] = Inventories.machines.power[i]+1 
Inventories.batteryBank.power[batteryBankCheck] = Inventories.batteryBank.power[batteryBankCheck]-1 
end 

if Inventories.batteryBank.pos[batteryBankCheck] == Inventories.machines.pos[i]+WidthOfWorld and Inventories.batteryBank.power[batteryBankCheck]>0 and Inventories.machines.power[i]<3000 then 
Inventories.machines.power[i] = Inventories.machines.power[i]+1 
Inventories.batteryBank.power[batteryBankCheck] = Inventories.batteryBank.power[batteryBankCheck]-1 
end 

if Inventories.batteryBank.pos[batteryBankCheck] == Inventories.machines.pos[i]-WidthOfWorld and Inventories.batteryBank.power[batteryBankCheck]>0 and Inventories.machines.power[i]<3000 then 
Inventories.machines.power[i] = Inventories.machines.power[i]+1 
Inventories.batteryBank.power[batteryBankCheck] = Inventories.batteryBank.power[batteryBankCheck]-1 
end 


end --ends for i = 1,#Inventories.batteryBank.power do 

for i = 1,#Inventories.Wire.pos do 

if Inventories.batteryBank.pos[batteryBankCheck] == Inventories.Wire.pos[i]+1 and Inventories.batteryBank.power[batteryBankCheck]>0 and Inventories.Wire.power[i]<1 then 
Inventories.Wire.power[i] = Inventories.Wire.power[i]+1 
Inventories.batteryBank.power[batteryBankCheck] = Inventories.batteryBank.power[batteryBankCheck]-1 
end 

if Inventories.batteryBank.pos[batteryBankCheck] == Inventories.Wire.pos[i]-1 and Inventories.batteryBank.power[batteryBankCheck]>0 and Inventories.Wire.power[i]<1 then 
Inventories.Wire.power[i] = Inventories.Wire.power[i]+1 
Inventories.batteryBank.power[batteryBankCheck] = Inventories.batteryBank.power[batteryBankCheck]-1 
end 

if Inventories.batteryBank.pos[batteryBankCheck] == Inventories.Wire.pos[i]+WidthOfWorld and Inventories.batteryBank.power[batteryBankCheck]>0 and Inventories.Wire.power[i]<1 then 
Inventories.Wire.power[i] = Inventories.Wire.power[i]+1 
Inventories.batteryBank.power[batteryBankCheck] = Inventories.batteryBank.power[batteryBankCheck]-1 
end 

if Inventories.batteryBank.pos[batteryBankCheck] == Inventories.Wire.pos[i]-WidthOfWorld and Inventories.batteryBank.power[batteryBankCheck]>0 and Inventories.Wire.power[i]<1 then 
Inventories.Wire.power[i] = Inventories.Wire.power[i]+1 
Inventories.batteryBank.power[batteryBankCheck] = Inventories.batteryBank.power[batteryBankCheck]-1 
end 


end --ends for i = 1,#Inventories.batteryBank.power do 


end --ends if Inventories.batteryBank.power[CheckGeneratorCounter]~= nil then 

end 

end 
function DrawPowerStorage()
if Inventories.batteryBank.power[BatteryBankBeingOpened] ~= nil then 
love.graphics.rectangle("line",1000,300,100,100)
love.graphics.print(Inventories.batteryBank.power[BatteryBankBeingOpened],1100,300)
end 
end 

function DrawCrafting()
if InventoryOpened == true then 
local MaxX = love.graphics.getWidth()
local MaxY = love.graphics.getHeight() 
if love.mouse.isDown("r") == true and Inventory.length[EquippedItem] ~= nil then 
local mouseX = love.mouse.getX()
local mouseY = love.mouse.getY()

local PressingSlot1 = false
local PressingSlot2 = false
local PressingSlot3 = false
local PressingSlot4 = false
PressingSlot5 = false 


 
if mouseX>MaxX-400 and mouseX<MaxX-300 and mouseY>200+MaxY/2 and mouseY<300+MaxY/2 then --mouseY>MaxY-300 and mouseY<300
PressingSlot1 = true 
end 

if mouseX>MaxX-300 and mouseX<MaxX-300+100 and mouseY>200+MaxY/2 and mouseY<300+MaxY/2 then 
PressingSlot2 = true 
end 

if mouseX>MaxX-400 and mouseX<MaxX-300 and mouseY>300+MaxY/2 and mouseY<400+MaxY/2 then 
PressingSlot3 = true 
end 

if mouseX>MaxX-300 and mouseX<MaxX-300+100 and mouseY>300+MaxY/2 and mouseY<400+MaxY/2 then 
PressingSlot4 = true 
end 

if mouseX>MaxX-200 and mouseX<MaxX-100 and mouseY>250+MaxY/2 and mouseY<350+MaxY/2 then 
PressingSlot5 = true 
end 

if ItemBeingDragged == nil then --makes it so you cant put two items in at the same time, if you are dragging a block you cant insert it the item in the equippedslot

if PressingSlot1 == true then 
if  CraftingTableSlots[1] == nil or CraftingTableSlots[1] == Inventory.item[EquippedItem] then 
InsertItemInCraftingTableSlotsDelay = InsertItemInCraftingTableSlotsDelay+1 
if InsertItemInCraftingTableSlotsDelay == 5 then 
InsertItemInCraftingTableSlotsDelay = 0 
CraftingTableSlots[1] = Inventory.item[EquippedItem]
CraftingTableSlots.length[1] = CraftingTableSlots.length[1] + 1 
RemoveItem(EquippedItem)
end 
end 
end 

if PressingSlot2 == true then 
if CraftingTableSlots[2] == nil or CraftingTableSlots[2] == Inventory.item[EquippedItem] then 
InsertItemInCraftingTableSlotsDelay = InsertItemInCraftingTableSlotsDelay+1 
if InsertItemInCraftingTableSlotsDelay == 5 then 
InsertItemInCraftingTableSlotsDelay = 0 
CraftingTableSlots[2] = Inventory.item[EquippedItem]
CraftingTableSlots.length[2] = CraftingTableSlots.length[2] + 1 
RemoveItem(EquippedItem)
end 
end 
end

if PressingSlot3 == true then 
if CraftingTableSlots[3] == nil or CraftingTableSlots[3] == Inventory.item[EquippedItem] then
InsertItemInCraftingTableSlotsDelay = InsertItemInCraftingTableSlotsDelay+1 
if InsertItemInCraftingTableSlotsDelay == 5 then
InsertItemInCraftingTableSlotsDelay = 0 
CraftingTableSlots[3] = Inventory.item[EquippedItem]
CraftingTableSlots.length[3] = CraftingTableSlots.length[3] + 1 
RemoveItem(EquippedItem)
end 
end 
end 

if PressingSlot4 == true then 
if CraftingTableSlots[4] == nil or CraftingTableSlots[4] == Inventory.item[EquippedItem] then 
InsertItemInCraftingTableSlotsDelay = InsertItemInCraftingTableSlotsDelay+1 
if InsertItemInCraftingTableSlotsDelay == 5 then
InsertItemInCraftingTableSlotsDelay = 0 
CraftingTableSlots[4] = Inventory.item[EquippedItem]
CraftingTableSlots.length[4] = CraftingTableSlots.length[4] + 1 
RemoveItem(EquippedItem)
end
end 
end 
end 

end 



if CraftingTableSlots[1] ~= nil then 
love.graphics.draw(CraftingTableSlots[1],MaxX-400,200+MaxY/2,0,3)
love.graphics.print(CraftingTableSlots.length[1],MaxX-400,200+MaxY/2)
end 

if CraftingTableSlots[2] ~= nil then 
love.graphics.draw(CraftingTableSlots[2],MaxX-300,200+MaxY/2,0,3)
love.graphics.print(CraftingTableSlots.length[2],MaxX-300,200+MaxY/2)
end 

if CraftingTableSlots[3] ~= nil then 
love.graphics.draw(CraftingTableSlots[3],MaxX-400,300+MaxY/2,0,3)
love.graphics.print(CraftingTableSlots.length[3],MaxX-400,300+MaxY/2)
end 

if CraftingTableSlots[4] ~= nil then 
love.graphics.draw(CraftingTableSlots[4],MaxX-300,300+MaxY/2,0,3)
love.graphics.print(CraftingTableSlots.length[4],MaxX-300,300+MaxY/2)
end 

if CraftingTableSlots[5] ~= nil then 
love.graphics.draw(CraftingTableSlots[5],MaxX-200,250+MaxY/2,0,3)
love.graphics.print(CraftingTableSlots.length[5],MaxX-200,250+MaxY/2)
end 

love.graphics.setColor(0,0,0)

love.graphics.rectangle("line",MaxX-300,200+MaxY/2,100,100)
love.graphics.rectangle("line",MaxX-400,200+MaxY/2,100,100)
love.graphics.rectangle("line",MaxX-400,300+MaxY/2,100,100)
love.graphics.rectangle("line",MaxX-300,300+MaxY/2,100,100)
love.graphics.rectangle("line",MaxX-200,250+MaxY/2,100,100)

love.graphics.setColor(255,255,255)

CraftingCounter = 0 
if PressingSlot5 == true and CraftingTableSlots[5] ~= nil then 
for i = 1, CraftingTableSlots.length[5] do 
InsertItem(CraftingTableSlots[5])
end

for i = 1,5 do 
if CraftingTableSlots.length[i]~= 0 then 
CraftingTableSlots.length[i] = CraftingTableSlots.length[i]-1 
end 
if CraftingTableSlots.length[i] == 0 then 
CraftingTableSlots[i] = nil 
end 

end 
--CraftingTableSlots[5] = nil
--CraftingTableSlots[4] = nil 
--CraftingTableSlots[3] = nil 
--CraftingTableSlots[2] = nil 
--CraftingTableSlots[1] = nil 
PressingSlot5 = false 
end 






--end 


if CraftingTableSlots[1] == nil and CraftingTableSlots[2] == nil and CraftingTableSlots[3] == nil and CraftingTableSlots[4] == nil then 
CraftingTableSlots[5] = nil 
CraftingTableSlots.length[5] = 0 
end 

if CraftingTableSlots[1] ~= nil or CraftingTableSlots[2] ~= nil or CraftingTableSlots[3] ~= nil or CraftingTableSlots[4] ~= nil then 

if CraftingTableSlots[1] == woodPlank and CraftingTableSlots[3] == woodPlank and CraftingTableSlots[2] == nil and CraftingTableSlots[4] == nil then 
--CraftingTableSlots[5] = stick
--CraftingTableSlots.length[5] = 1 

elseif CraftingTableSlots[1] == PhysicsWood and CraftingTableSlots[2] == nil and CraftingTableSlots[3] == nil and CraftingTableSlots[4] == nil then 
CraftingTableSlots[5] = woodPlank
CraftingTableSlots.length[5] = 1 
CraftingTableSlots.length[5] = 1 


elseif CraftingTableSlots[1] == woodPlank and CraftingTableSlots[2] == woodPlank and CraftingTableSlots[3] == woodPlank and CraftingTableSlots[4] == woodPlank then 
CraftingTableSlots[5] = CraftingTable
CraftingTableSlots.length[5] = 1 

end 
end 






--if InventoryOpened == false then 
--if CraftingTableOpened == true then 


--end
--end 

else 

if CraftingTableOpened == true then 

if love.mouse.isDown("r") == true then 

local OnSlot1 = false 
local OnSlot2 = false 
local OnSlot3 = false 
local OnSlot4 = false 
local OnSlot5 = false 
local OnSlot6 = false 
local OnSlot7 = false 
local OnSlot8 = false 
local OnSlot9 = false 
local OnSlot10 = false 
local itemToInsert = Inventory.item[EquippedItem]

local xMin = 900 
local xMax = 1000 
local yMin = 200 
local yMax = 300
local PosBeingChecked = 0 

if Inventory.item[EquippedItem] ~= nil then 
if x>xMin and x<xMax and y>yMin and y<yMax then 
OnSlot1 = true 
InsertItemInCraftingTableSlotsDelay = InsertItemInCraftingTableSlotsDelay+1 
if InsertItemInCraftingTableSlotsDelay == 5 then 
InsertItemInCraftingTableSlotsDelay = 0 
CraftingTableSlots[1] = Inventory.item[EquippedItem] 
CraftingTableSlots.length[1] = CraftingTableSlots.length[1] + 1 
RemoveItem(EquippedItem)
end 
end 

local xMin = 1000
local xMax = 1100 

if x>xMin and x<xMax and y>yMin and y<yMax then 
OnSlot2 = true 
InsertItemInCraftingTableSlotsDelay = InsertItemInCraftingTableSlotsDelay+1 
if InsertItemInCraftingTableSlotsDelay == 5 then 
InsertItemInCraftingTableSlotsDelay = 0 
CraftingTableSlots[2] = Inventory.item[EquippedItem] 
CraftingTableSlots.length[2] = CraftingTableSlots.length[2]+1
RemoveItem(EquippedItem)
end 
end 

xMin = 1100 
xMax = 1200 

if x>xMin and x<xMax and y>yMin and y<yMax then 
OnSlot3 = true 
InsertItemInCraftingTableSlotsDelay = InsertItemInCraftingTableSlotsDelay+1 
if InsertItemInCraftingTableSlotsDelay == 5 then 
InsertItemInCraftingTableSlotsDelay = 0 
CraftingTableSlots[3] = Inventory.item[EquippedItem] 
CraftingTableSlots.length[3] = CraftingTableSlots.length[3]+1
RemoveItem(EquippedItem)
end 
end 

xMin = 900 
xMax = 1000 
yMin = 300 
yMax = 400 


if x>xMin and x<xMax and y>yMin and y<yMax then 
OnSlot4 = true 
InsertItemInCraftingTableSlotsDelay = InsertItemInCraftingTableSlotsDelay+1 
if InsertItemInCraftingTableSlotsDelay == 5 then 
InsertItemInCraftingTableSlotsDelay = 0 
CraftingTableSlots[4] = Inventory.item[EquippedItem] 
CraftingTableSlots.length[4] = CraftingTableSlots.length[4]+1
RemoveItem(EquippedItem)
end 
end 

xMin = 1000 
xMax = 1100


if x>xMin and x<xMax and y>yMin and y<yMax then 
OnSlot5 = true 
InsertItemInCraftingTableSlotsDelay = InsertItemInCraftingTableSlotsDelay+1 
if InsertItemInCraftingTableSlotsDelay == 5 then 
InsertItemInCraftingTableSlotsDelay = 0 
CraftingTableSlots[5] = Inventory.item[EquippedItem] 
CraftingTableSlots.length[5] = CraftingTableSlots.length[5]+1
RemoveItem(EquippedItem)
end 
end 

xMin = 1100 
xMax = 1200 

if x>xMin and x<xMax and y>yMin and y<yMax then 
OnSlot6 = true 
InsertItemInCraftingTableSlotsDelay = InsertItemInCraftingTableSlotsDelay+1 
if InsertItemInCraftingTableSlotsDelay == 5 then 
InsertItemInCraftingTableSlotsDelay = 0 
CraftingTableSlots[6] = Inventory.item[EquippedItem] 
CraftingTableSlots.length[6] = CraftingTableSlots.length[6]+1
RemoveItem(EquippedItem)
end 
end 

xMin = 900 
xMax = 1000 
yMin = 400 
yMax = 500 

if x>xMin and x<xMax and y>yMin and y<yMax then 
OnSlot7 = true 
InsertItemInCraftingTableSlotsDelay = InsertItemInCraftingTableSlotsDelay+1 
if InsertItemInCraftingTableSlotsDelay == 5 then 
InsertItemInCraftingTableSlotsDelay = 0 
CraftingTableSlots[7] = Inventory.item[EquippedItem] 
CraftingTableSlots.length[7] = CraftingTableSlots.length[7]+1
RemoveItem(EquippedItem)
end 
end 

xMin = 1000 
xMax = 1100 


if x>xMin and x<xMax and y>yMin and y<yMax then 
OnSlot8 = true 
InsertItemInCraftingTableSlotsDelay = InsertItemInCraftingTableSlotsDelay+1 
if InsertItemInCraftingTableSlotsDelay == 5 then 
InsertItemInCraftingTableSlotsDelay = 0 
CraftingTableSlots[8] = Inventory.item[EquippedItem] 
CraftingTableSlots.length[8] = CraftingTableSlots.length[8]+1
RemoveItem(EquippedItem)
end 
end 

xMin = 1100
xMax = 1200 

if x>xMin and x<xMax and y>yMin and y<yMax then 
OnSlot9 = true 
InsertItemInCraftingTableSlotsDelay = InsertItemInCraftingTableSlotsDelay+1 
if InsertItemInCraftingTableSlotsDelay == 5 then 
InsertItemInCraftingTableSlotsDelay = 0 
CraftingTableSlots[9] = Inventory.item[EquippedItem] 
CraftingTableSlots.length[9] = CraftingTableSlots.length[9]+1
RemoveItem(EquippedItem)
end 
end 


end --ends if Inventory.item[EquippedItem] ~= nil 

if x>1200 and x<1300 and y>300 and y<400 and CraftingTableSlots[10] ~= nil then 

for i = 1, CraftingTableSlots.length[10] do 
InsertItem(CraftingTableSlots[10])
CraftingTableSlots.length[10] = CraftingTableSlots.length[10]-1 
if CraftingTableSlots.length[10] == 0 then 
CraftingTableSlots[10] = nil 
end 

end 
for i = 1, 9 do 
if CraftingTableSlots.length[i] ~= 0 then 
CraftingTableSlots.length[i] = CraftingTableSlots.length[i]-1 
end
if CraftingTableSlots.length[i] == 0 then 
CraftingTableSlots[i] = nil 
end  

end 


end 

end 

love.graphics.rectangle("line",900,200,100,100)
love.graphics.rectangle("line",1000,200,100,100)
love.graphics.rectangle("line",1100,200,100,100)

love.graphics.rectangle("line",900,300,100,100)
love.graphics.rectangle("line",1000,300,100,100)
love.graphics.rectangle("line",1100,300,100,100)

love.graphics.rectangle("line",900,400,100,100)
love.graphics.rectangle("line",1000,400,100,100)
love.graphics.rectangle("line",1100,400,100,100)

love.graphics.rectangle("line",1200,300,100,100)

if CraftingTableSlots[1] ~= nil then 
love.graphics.draw(CraftingTableSlots[1],900,200)
love.graphics.print(CraftingTableSlots.length[1],900,200)
end 
if CraftingTableSlots[2] ~= nil then 
love.graphics.draw(CraftingTableSlots[2],1000,200)
love.graphics.print(CraftingTableSlots.length[2],1000,200)
end 
if CraftingTableSlots[3] ~= nil then 
love.graphics.draw(CraftingTableSlots[3],1100,200)
love.graphics.print(CraftingTableSlots.length[3],1100,200)
end 
if CraftingTableSlots[4] ~= nil then 
love.graphics.draw(CraftingTableSlots[4],900,300)
love.graphics.print(CraftingTableSlots.length[4],900,300)
end 
if CraftingTableSlots[5] ~= nil then 
love.graphics.draw(CraftingTableSlots[5],1000,300)
love.graphics.print(CraftingTableSlots.length[5],1000,300)
end 
if CraftingTableSlots[6] ~= nil then 
love.graphics.draw(CraftingTableSlots[6],1100,300)
love.graphics.print(CraftingTableSlots.length[6],1100,300)
end 
if CraftingTableSlots[7] ~= nil then 
love.graphics.draw(CraftingTableSlots[7],900,400)
love.graphics.print(CraftingTableSlots.length[7],900,400)
end 
if CraftingTableSlots[8] ~= nil then 
love.graphics.draw(CraftingTableSlots[8],1000,400)
love.graphics.print(CraftingTableSlots.length[8],1000,400)
end 
if CraftingTableSlots[9] ~= nil then 
love.graphics.draw(CraftingTableSlots[9],1100,400)
love.graphics.print(CraftingTableSlots.length[9],1100,400)
end 
if CraftingTableSlots[10] ~= nil then 
love.graphics.draw(CraftingTableSlots[10],1200,300)
love.graphics.print(CraftingTableSlots.length[10],1200,300)
end


for i = 1,43 do 
--local a = recipies 
if i == 1 then 
Table = recipies.plank
end 
if i == 2 then 
Table = recipies.stick 
end 
if i == 3 then 
Table = recipies.WoodPickaxeHead 
end 
if i == 4 then 
Table = recipies.stonePickaxeHead
end 
if i == 5 then 
Table = recipies.IronPickaxeHead 
end 
if i == 6 then 
Table = recipies.GoldPickaxeHead
end 
if i == 7 then 
Table = recipies.DiamondPickaxeHead 
end 
if i == 8 then 
Table = recipies.WoodAxeHead 
end 
if i == 9 then 
Table = recipies.StoneAxeHead
end 
if i == 10 then 
Table  = recipies.IronAxeHead
end 
if i == 11 then 
Table = recipies.GoldAxeHead
end 
if i == 12 then 
Table = recipies.DiamondAxeHead 
end 
if i == 13 then 
Table = recipies.DiamondAxeHead
end 
if i == 14 then 
Table = recipies.WoodPickaxe
end 
if i == 15 then 
Table = recipies.StonePickaxe 
end 
if i == 16 then 
Table = recipies.IronPickaxe 
end 
if i == 17 then 
Table = recipies.GoldPickaxe 
end 
if i == 18 then 
Table = recipies.DiamondPickaxe 
end 
if i == 19 then 
Table = recipies.WoodAxe 
end 
if i == 20 then 
Table = recipies.StoneAxe 
end 
if i == 21 then 
Table = recipies.IronAxe
end 
if i == 22 then 
Table = recipies.GoldAxe 
end 
if i == 23 then 
Table = recipies.DiamondAxe 
end 
if i == 24 then 
Table = recipies.WoodShovel 
end 
if i == 25 then 
Table = recipies.StoneShovel 
end 
if i == 26 then 
Table = recipies.IronShovel 
end 
if i == 27 then 
Table = recipies.GoldShovel 
end 
if i == 28 then 
Table  = recipies.DiamondShovel
end 
if i == 29 then 
Table = recipies.IronPlate 
end 
if i == 30 then 
Table = recipies.MachineBlock 
end 
if i == 31 then 
Table = recipies.CopperWire 
end 
if i == 32 then 
Table = recipies.ElectrumWire 
end 
if i == 33 then 
Table = recipies.ElectronicCircut 
end 
if i == 34 then 
Table = recipies.furnace 
end 
if i == 35 then 
Table = recipies.ElectricFurnace 
end 
if i == 36 then 
Table = recipies.Grinder 
end 
if i == 37 then 
Table = recipies.Compressor
end 
if i == 38 then 
Table = recipies.Generator 
end 
if i == 39 then 
Table = recipies.Rune 
end 
if i == 40 then 
Table = recipies.Wrench 
end 
if i == 41 then 
Table = recipies.BlastFurnace
end 
if i == 42 then 
Table = recipies.Coil 
end 
if i == 43 then 
Table = recipies.batteryBank
end 

local CraftItem = false  
--Table = recipies.plank
if Table[1] == CraftingTableSlots[1] and  Table[2] == CraftingTableSlots[2] and Table[3] == CraftingTableSlots[3] and Table[4] == CraftingTableSlots[4]  and Table[5] == CraftingTableSlots[5] and Table[6] == CraftingTableSlots[6] and Table[7] == CraftingTableSlots[7] and Table[8] == CraftingTableSlots[8] and Table[9] == CraftingTableSlots[9]  then 
CraftItem = true 
end 
if CraftItem == true then 
CraftingTableSlots[10] = Table[10] 

if Table[11] == nil then 
CraftingTableSlots.length[10] = 1
else 
CraftingTableSlots.length[10] = Table[11]
end 


end 
end 


local NewCraftingCounter = 0 



 






end 

end 

end 

function love.mousereleased(x,y,button)
BreakingBlock = false
BreakBlockCounter = 1
BreakingCounter = 0 
end


function love.draw()



--testDraw:draw()
love.graphics.draw(Background,0,0)
--love.graphics.setBackgroundColor(30,198,232)
love.graphics.setColor(255,255,255)

DrawBackground()
DrawWireOrientation()

love.graphics.print("FPS: "..tostring(love.timer.getFPS()),1000,10 )
drawTerrain()

ShowRecipies()

if InventoryOpened == false then
drawHotbar()
end
if InventoryOpened == true then
DrawInventory()
end

DrawMachine()

DrawWeapons()

ChooseAttackType()

if InventoryOpened == true or CraftingTableOpened == true then 
DrawCrafting()
end 

if RunicAltarOpened == true then 
DrawRunicAltar()
end 

if FurnaceOpened == true then 
PrintFurnace()
end 

if Visible == true then 
love.graphics.draw(Character,CharX,CharY,0,Scale/645,Scale/645) --CharX,CharY
end 

if collisionDown == true then
--love.graphics.print("CollisionDown",500,500)
end 
if collisionLeftFace == true then
--love.graphics.print("CollisionLeft",500,510)
end 
if collisionRightFace == true then 
--love.graphics.print("ColisionRight",500,520)
end
if collisionUpFace == true then 
--love.graphics.print("CollisionUp",500,530)
end 

if AbleToWalkOverBlock == true then 
love.graphics.print("AbleToWalkOverBlock",500,530)
end 



--love.graphics.print(BreakingCounter,500,540)


if GeneratorOpened == true then 
DrawGenerator()
end 



if ItemBeingDragged ~= nil then 
love.graphics.draw(ItemBeingDragged,love.mouse.getX(),love.mouse.getY())
love.graphics.print(LengthOfStackBeingDragged,love.mouse.getX(),love.mouse.getY())
end 


if NumberOfMachines ~= 0 then 
--love.graphics.print(Inventories.grinder.pos[NumberOfMachines],1050,300)
end 

if Inventories.machines.machineType[1] ~= nil then 
love.graphics.draw(Inventories.machines.machineType[#Inventories.machines.machineType],100,100)
end 

love.graphics.print(HealthOfPlayer.. " HP",1800,100)
love.graphics.print(HungerOfPlayer .. " Hunger",1800,115)

love.graphics.rectangle("line",RectX,RectY,25,25)


DrawPowerStorage()

if Inventories.trinketSlots[1] == DoubleJumpPendant or Inventories.trinketSlots[1] == HighJumpPendant  then 
if  jumpCounter>0 then 
jumpParticles:emit(8)
end 

end

love.graphics.draw(jumpParticles,1000+12,500+55)
love.graphics.draw(breakParticles,breakParticlesX,breakParticlesY,0,0.5,0.5)
love.graphics.draw(magicToolParticles,breakParticlesX,breakParticlesY,0,0.5,0.5)
love.graphics.draw(MagicParticles,magicParticleX,magicParticleY,0,0.5,0.5)
love.graphics.draw(SwordParticles,1015,490,0)

love.graphics.print("CLOSED BETA 0.2",100,950)
--love.graphics.print(StartOfLoop)
--love.graphics.print(EndOfLoop,0,100)
for i = 1,#ItemsBeingBroken.pos do 
love.graphics.print(ItemsBeingBroken.pos[i])
end 

DrawMobs()

--love.graphics.print(Mobs.trueX[1],100,200)
--love.graphics.print(Mobs.trueY[1],100,100)


--love.graphics.print(PosOfMob,300,300)
love.graphics.print(HitCounter)


end
